/*
 * This file is part of the Owl Positioning System (OwlPS) project.
 * It is subject to the copyright notice and license terms in the
 * COPYRIGHT.t2t file found in the top-level directory of this
 * distribution and at
 *   https://code.lm7.fr/mcy/owlps/src/master/COPYRIGHT.t2t
 * No part of the OwlPS Project, including this file, may be copied,
 * modified, propagated, or distributed except according to the terms
 * contained in the COPYRIGHT.t2t file; the COPYRIGHT.t2t file must be
 * distributed along with this file, either separately or by replacing
 * this notice by the COPYRIGHT.t2t file's contents.
 */


#include "realposition.hh"
#include "calibrationrequest.hh"
#include "referencepoint.hh"



Result RealPosition::compute(const Request &request)
{
  const Point3D *coordinates = nullptr ;

  const CalibrationRequest *calibration_request =
    dynamic_cast<const CalibrationRequest*>(&request) ;

  if (calibration_request)
    coordinates = static_cast<Point3D*>(
                    calibration_request->get_reference_point()) ;
  else
    coordinates = request.get_real_position() ;

  if (coordinates)
    return Result(&request, name, *coordinates) ;
  return Result(&request, name) ;
}
